
// Created by liuheng@bonree.com on 2019/11/14 0014.
// Copyright © 2007-2019 Bonree Data Technology Co.,Ltd
// All rights reserved


#ifndef _BONREE_SDK_BTDETAIL_BT_H_
#define _BONREE_SDK_BTDETAIL_BT_H_

#include "common/common.h"
#include "common/symbols.h"
#include "common/structs.h"

#ifdef __cplusplus
extern "C" {
#endif

//struct bt_t {
//    void *ins;
//};
typedef struct sdk_object_t bt_t;

//结束业务
//参数：bt[in]: bt_t* 要结束的业务对象
//参数：options[in]: 参数选项
//参数：http_resp[in]: http 响应信息（可选，非http 请求业务该参数传null）
//返回值： 0：成功， 非0：失败
BONREE_SDK_API int br_finish_bt(const bt_t* bt, const bt_finish_options_t* options, const http_resp_data_t* http_resp);

//业务(http 请求业务)添加http 请求数据
//参数：bt[in]: bt_t* 要结束的业务对象
//参数：http_req[in]: http 请求信息
BONREE_SDK_API int br_bt_set_http_req(const bt_t* bt,const http_req_data_t* http_req);

//业务(http 请求业务)添加http 响应数据
//参数：bt[in]: bt_t* 要结束的业务对象
//参数：http_resp[in]: http 响应信息
BONREE_SDK_API int br_bt_set_http_resp(const bt_t* bt, const http_resp_data_t* http_resp);

//添加一个业务错误信息
//参数：bt[in]: bt_t* 业务对象
//参数: error[in], bt_error_t* 业务错误信息
//返回值： 0：成功， 非0：失败
BONREE_SDK_API int br_add_bt_error(const bt_t* bt, const bt_error_t* error);

#ifdef __cplusplus
}
#endif

#endif //_BONREE_SDK_BTDETAIL_BT_H_
