#ifndef _BONREE_SDK_COMMON_ENUMS_H_
#define _BONREE_SDK_COMMON_ENUMS_H_

#ifdef __cplusplus
extern "C" {
#endif

enum SdkInitFlag
{
    INIT_FLAG_FORKABLE = 0x1,
    INIT_FLAG_PHPCLI = 0x2,
};

//探针类型
enum AgentType
{
	AGENT_TYPE_UNKNOWN = 0,			
    AGENT_PHP = 3,
    AGENT_PYTHON = 4,
    AGENT_NODEJS = 5,
    AGENT_C = 6,
    AGENT_GO = 7,
    AGENT_RUBY = 8,
    AGENT_LUA = 10,
  	AGENT_NGINX = 12,
};

//后端类型
enum BackendType {
	BACKEND_TYPE_UNKNOWN = 0,			//unknown类型
	BACKEND_TYPE_CUSTOM = 300,			//web展示拼接方式： Custom-xxxx

	//SQL
	BACKEND_TYPE_MYSQL = 1,				//web展示拼接方式： 数据库名-MySQL-host
	BACKEND_TYPE_ORACLE = 2,			//web展示拼接方式： 数据库名-Oracle-host
	BACKEND_TYPE_MSSQLSERVER = 3,		//web展示拼接方式： 数据库名-SQLServer-host
	BACKEND_TYPE_IBM_DB2 = 4,			//web展示拼接方式： 数据库名-DB2-host
	BACKEND_TYPE_POSTGRESQL = 5,		//web展示拼接方式： 数据库名-PostgreSQL-host
	BACKEND_TYPE_SHENTONG = 6,			//web展示拼接方式： 数据库名-ShenTong-host
	BACKEND_TYPE_SYBASE = 7,			//web展示拼接方式： 数据库名-Sybase-host
	BACKEND_TYPE_IBM_INFOMIX = 8,		//web展示拼接方式： 数据库名-IBM-Infomix-host
	BACKEND_TYPE_MS_ACCESS = 9,			//web展示拼接方式： 数据库名-MSAccess-filename
	BACKEND_TYPE_SQLITE = 10,			//web展示拼接方式： 数据库名-SQLite-filename
	BACKEND_TYPE_GENERIC_JDBC = 11,     //web展示拼接方式： 数据库名-JDBC-host

	//NOSQL
	BACKEND_TYPE_MONGODB = 101,			//web展示拼接方式： Mongo-host:port
	BACKEND_TYPE_MEMCACHE = 102,		//web展示拼接方式： Memcached
	BACKEND_TYPE_REDIS = 103,			//web展示拼接方式： Redis-host:port
	BACKEND_TYPE_COUCHBASE = 104,		//web展示拼接方式： CouchBase-host
	BACKEND_TYPE_COUCHDB = 105,			//web展示拼接方式： CouchDB-host:port
	BACKEND_TYPE_CASSANDRA = 106,		//web展示拼接方式： CASSANDRA-host:port
	BACKEND_TYPE_SSDB = 107,			//web展示拼接方式： SSDB-host:port

	//远程调用
	BACKEND_TYPE_HTTP = 201,			//web展示拼接方式： Http-host:port
	BACKEND_TYPE_THRIFT = 202,			//web展示拼接方式： Thrift-host:port
	BACKEND_TYPE_WEBSERVICE = 203,      //web展示拼接方式： WebService-host:port
	BACKEND_TYPE_WEBSOCKET = 204,		//web展示拼接方式： WebSocket-host:port
	BACKEND_TYPE_WCF = 205,				//web展示拼接方式： WCF-host:port
	BACKEND_TYPE_WEB_API_1 = 206,		//web展示拼接方式： Web-Api1-host:port
	BACKEND_TYPE_WEB_API_2 = 207,		//web展示拼接方式： Web-Api2-host:port
	BACKEND_TYPE_DUBBO = 208,			//web展示拼接方式： Dubbo-host:por
	BACKEND_TYPE_SUN_RMI = 209,			//web展示拼接方式： RMI-host:port
	BACKEND_TYPE_SOCKET = 210,			//web展示拼接方式： Sock-host:port
	BACKEND_TYPE_HSF = 211,				//web展示拼接方式： HSF-host:port
	BACKEND_TYPE_JMS = 212,				//web展示拼接方式： JMS-host:port
	BACKEND_TYPE_SPRING_JMS = 213,      //web展示拼接方式： Spring-JMS-host:port
	BACKEND_TYPE_RABBITMQ = 214,		//web展示拼接方式： RabbitMQ-host:port
	BACKEND_TYPE_CXF = 215,				//web展示拼接方式： CXF-host:port
	BACKEND_TYPE_WTC = 216,				//web展示拼接方式： WTC-host:port
	BACKEND_TYPE_GRPC = 217,			//web展示拼接方式： GRPC-host:port
	BACKEND_TYPE_AXIS = 218,			//web展示拼接方式： AXIS-host:port
	BACKEND_TYPE_SOAP = 219,			//web展示拼接方式： SOAP-host:port
	BACKEND_TYPE_SOLR = 220,			//web展示拼接方式： SOLR-host:port
	BACKEND_TYPE_MSMQ = 221,			//web展示拼接方式： MSMQ-host:port
	BACKEND_TYPE_CIB_RPC = 222,			//web展示拼接方式： CIB-host:port  (兴业证券rpc)
	BACKEND_TYPE_MOTAN = 223,			//web展示拼接方式： MOTAN-host:port  (新浪微博rpc)
	BACKEND_TYPE_IBMMQ = 224,			//web展示拼接方式： IBMMQ-host:port
	BACKEND_TYPE_ROCKETMQ = 225,		//web展示拼接方式： RocketMQ-host:port
	BACKEND_TYPE_ACTIVEMQ = 226,		//web展示拼接方式： ActiveMQ-host:port
	BACKEND_TYPE_HBASE = 227,			//web展示拼接方式： Hbase-host:port
	BACKEND_TYPE_KAFKA = 228,			//web展示拼接方式： Kafka-host:port
	BACKEND_TYPE_ES = 229				//web展示拼接方式： ES-host:port ( elasticsearch  )
};

//业务类型
enum BTType {
	BT_UNKNOWN = 0,
	BT_PHP_CLI = 100,
	BT_PHP_WEB = 101,
	BT_PHP_MVC = 102,
	BT_PHP_WEB_SERVICE = 103,
	BT_NODEJS_WEB = 150,
	BT_PYTHON_CLI = 200,
	BT_PYTHON_WEB = 201,
	BT_PYTHON_WSGI = 202,
	BT_PYTHON_TORNADO = 203,
	BT_BACKGROUND_TASK = 300,
	BT_C_USER = 350,
	BT_GO_USER = 400,
  	BT_HTTP = 450
};

//日志级别
enum LOG_LEVEL
{
    LOG_LEVEL_DEBUG = 1,
    LOG_LEVEL_INFO,
    LOG_LEVEL_WARN,
    LOG_LEVEL_ERROR,
    LOG_LEVEL_OFF
};

//用户体验
enum UserExperienceType {
    USER_EXPERIENCE_TYPE_GOOD =         1,    //健康
    USER_EXPERIENCE_TYPE_SLOW =         2,    //慢
    USER_EXPERIENCE_TYPE_VERY_SLOW =    3,    //很慢
    USER_EXPERIENCE_TYPE_STALL =        4,    //停滞
    USER_EXPERIENCE_TYPE_ERROR =        5,    //错误
};

//错误类型
enum ErrorType
{
    ERROR_TYPE_HTTP=1,
    ERROR_TYPE_EXCEPTION,
};

//events事件类型
enum EventType {
    //Info events
    EVENT_TYPE_INFO                             = 0,    //custom info
    EVENT_TYPE_PROCESS_RESTART                  = 1,    //进程重启
    EVENT_TYPE_ENV_MODIFY                       = 2,    //环境变量、VM环境变量变更
    EVENT_TYPE_CIRCUIT_BREAK                    = 3,    //探针熔断
    EVENT_TYPE_CIRCUIT_BREAK_RESET              = 4,    //探针熔断复位
    EVENT_TYPE_DEPLOYMENT_CHANGE                = 5,    //部署变更

    //Availability events
    EVENT_TYPE_AVAILABILITY_EVENT               = 20,   //Custom availability event
    EVENT_TYPE_UNEXPECTED_LOW_LOAD              = 21,   //Unexpected low traffic
    EVENT_TYPE_HOST_UNAVAILABLE                 = 22,   //Host or monitoring unavailable
    EVENT_TYPE_PROCESS_UNAVAILABLE              = 23,   //Process unavailable
    EVENT_TYPE_HOST_LOG_AVAILABILITY            = 24,   //Availability log pattern found
    EVENT_TYPE_PROCESS_LOG_AVAILABILITY         = 25,   //Availability log pattern found

    //Error events
    EVENT_TYPE_ERROR_EVENT                      = 40,   //Custom error event
    EVENT_TYPE_HIGH_NETWORK_ERROR_RATED         = 41,   //High number of network errors
    EVENT_TYPE_PROCESS_CRASH                    = 42,   //process crash
    EVENT_TYPE_PROCESS_OUT_OF_MEMORY            = 43,   //process out of memory
    EVENT_TYPE_HOST_LOG_ERROR                   = 44,   //Error log pattern found
    EVENT_TYPE_PROCESS_LOG_ERROR                = 45,   //Error log pattern found

    //Slowdown events
    EVENT_TYPE_PERFORMANCE_EVENT                = 60,   //Custom performance event
    EVENT_TYPE_RESPONSE_TIME_DEGRADED           = 61,   //Response time degradation
    EVENT_TYPE_HOST_LOG_PERFORMANCE             = 62,   //Performance log pattern found
    EVENT_TYPE_PROCESS_LOG_PERFORMANCE          = 63,   //Performance log pattern found

    //Resource events
    EVENT_TYPE_RESOURCE_EVENT                   = 80,   //Custom resource contention event
    EVENT_TYPE_UNEXPECTED_HIGH_LOAD             = 81,   //Unexpected high traffic
    EVENT_TYPE_CPU_SATURATED                    = 82,   //CPU saturation
    EVENT_TYPE_MEMORY_SATURATED                 = 83,   //Memory saturation
    EVENT_TYPE_LOW_DISK_SPACE                   = 84,   //Low disk space
    EVENT_TYPE_SLOW_DISK                        = 85,   //Slow disk
    EVENT_TYPE_HOST_DISK_LOW_INODES             = 86,   //Low number of inodes available
    EVENT_TYPE_HIGH_NETWORK_UTILIZATION         = 87,   //High network utilization
    EVENT_TYPE_HOST_HIGH_GC_ACTIVITY            = 88,   //Long garbage-collection time
    EVENT_TYPE_HOST_FD_SATURATED                = 89,   //fd saturation
};

#ifdef __cplusplus
}
#endif

#endif // _BONREE_SDK_COMMON_ENUMS_H_
