
// Created by liuheng@bonree.com on 2019/11/14 0014.
// Copyright © 2007-2019 Bonree Data Technology Co.,Ltd
// All rights reserved


#ifndef _BONREE_SDK_SDK_H_
#define _BONREE_SDK_SDK_H_


#include "btdetail/bt_detail.h"

#ifdef __cplusplus
extern "C" {
#endif

//初始化sdk 
//参数：flag[in]: 初始化标识选项
//参数：str_t cfg_path: 配置文件路径
//返回值：0：成功， 非0： 失败
int BONREE_SDK_API br_init_sdk_with_cfg(str_t cfg_path, int flag);

//初始化sdk 
//option[in]: 初始化选项参数
//返回值：0：成功， 非0： 失败
int BONREE_SDK_API br_init_sdk(const sdk_options_t* option);

//释放sdk对象
//返回值：0：成功， 非0： 失败;
int BONREE_SDK_API br_un_init_sdk();

//更新容器信息 对应的数据更新到sdk
//参数：update_info[in], container_info_t*, 需要变更的数据；
//返回值：0：成功， 非0： 失败;
int BONREE_SDK_API br_update_container_info(container_info_t *update_info);

//是否开启agent
//返回值 1：agent 开启， 0: agent 未开启;
int BONREE_SDK_API br_agent_enable();

//开始一个事务记录
//参数：transaction[out], transaction_t*, 开启的事务记录
//返回值：0：成功， 非0： 失败;
int BONREE_SDK_API br_open_transaction(transaction_t *transaction);

//结束一个事务记录
//参数：transaction[in], transaction_t*, 需要关闭的事务记录
//返回值：0：成功， 非0： 失败;
int BONREE_SDK_API br_close_transaction(transaction_t *transaction);

//设置日志级别 Deprecated
//参数：level[in], LOG_LEVEL, 日志级别
//返回值：0：成功， 非0： 失败;
int BONREE_SDK_API br_set_logging_level(enum LOG_LEVEL level);

#ifdef __cplusplus
}
#endif

#endif //_BONREE_SDK_SDK_H_
