
// Created by liuheng@bonree.com on 2019/11/14 0014.
// Copyright © 2007-2019 Bonree Data Technology Co.,Ltd
// All rights reserved


#ifndef _BONREE_SDK_TRACE_SPAN_H_
#define _BONREE_SDK_TRACE_SPAN_H_


#include "common/tags.h"
#include "btdetail/be_call.h"

#ifdef __cplusplus
extern "C" {
#endif

//struct span_t {
//    void * ins;
//};
typedef struct sdk_object_t span_t;

//方法与后端调用关联
//参数：span[in]: span_t* 需要关联后端调用的方法
//参数：be_call[in], be_call_t*, 需要与方法关联的后端调用
//返回值： 0：成功， 非0： 失败
BONREE_SDK_API int br_link_to_be_call(const span_t* span,  const be_call_t* be_call);

//设置tag
//参数： span[in]: span_t* 需要设置tag的span_t 对象
//参数： key[in]: str_t* tag的key
//参数： value[in]: str_t* tag的value
//返回值： 0：成功， 非0： 失败
BONREE_SDK_API int br_set_tag(const span_t* span, const str_t* key, const str_t* value);

//设置错误信息
//参数： span[in]: span_t* 需要设置错误信息的span_t 对象
//参数： trace_error[in]：trace_error_t*, 需要设置的错误信息
//返回值： 0：成功， 非0： 失败
BONREE_SDK_API int br_set_trace_error(const span_t* span, const trace_error_t* trace_error);

//结束span
//参数： span[in]: span_t* 需要结束的span_t 对象
//参数： options[in]:finish_span_options_t* 结束span 选项参数
//返回值： 0：成功， 非0： 失败
BONREE_SDK_API int br_finish_span(const span_t* span, const finish_span_options_t* options);

#ifdef __cplusplus
}
#endif

#endif //_BONREE_SDK_TRACE_SPAN_H_
