
// Created by liuheng@bonree.com on 2019/11/14 0014.
// Copyright © 2007-2019 Bonree Data Technology Co.,Ltd
// All rights reserved


#ifndef _BONREE_SDK_TRACE_TRACER_H_
#define _BONREE_SDK_TRACE_TRACER_H_


#include "trace/span.h"

#ifdef __cplusplus
extern "C" {
#endif

//struct tracer_t {
//    void* ins;
//};
typedef struct sdk_object_t tracer_t;

//开始span
//参数：tracer[in]: tracer_t*， 调用链对象
//参数：options[in]: start_span_options_t*, 创建span的选项参数
//参数：span[out]: span_t* 创建的span_t 对象
//返回值： 0：成功， 非0: 失败
BONREE_SDK_API int br_start_span(const tracer_t* tracer, const struct start_span_options_t* options, span_t* span);

//参数： tracer[in]: span_t* 需要设置tag的span_t 对象
//参数： key[in]: str_t* tag的key
//参数： value[in]: str_t* tag的value
//返回值： 0：成功， 非0： 失败
BONREE_SDK_API int br_set_trace_tag(const tracer_t* tracer, const str_t* key, const str_t* value);

//结束tracer
//参数：tracer[in]: tracer_t*，需要结束的tracer
//返回值： 0：成功， 非0: 失败
BONREE_SDK_API int br_finish_tracer(const tracer_t* tracer);

#ifdef __cplusplus
}
#endif

#endif //_BONREE_SDK_TRACE_TRACER_H_
