
// Created by liuheng@bonree.com on 2019/11/15 0015.
// Copyright © 2007-2019 Bonree Data Technology Co.,Ltd
// All rights reserved


#ifndef _BONREE_SDK_UTILS_STR_UTIL_H_
#define _BONREE_SDK_UTILS_STR_UTIL_H_

#include "common/structs.h"
#include "common/symbols.h"

#ifdef __cplusplus
extern "C" {
#endif

//申请指定大小的字符数组
//参数：str[out], 申请的字符数组
//参数：size[in], 字符数组大小
//返回值:0 成功， 非0失败
BONREE_SDK_API int str_malloc(str_t *str, unsigned int size);

//释放申请的字符数组
//参数：str[in], 待释放的字符数组
//返回值:0 成功， 非0失败
BONREE_SDK_API int str_free(str_t *str);

//申请字符串数组
//参数：strs[out], 申请的字符串数组
//参数：size[in], 要申请的字符串数组大小
//返回值：0；成功， 非0：失败
BONREE_SDK_API int str_list_malloc(str_t **strs, unsigned int size);

//释放字符串数组
//参数：strs[out], 待释放的字符串数组
//参数：size[in], 待释放的字符串数组大小
//返回值：0；成功， 非0：失败
BONREE_SDK_API int str_list_free(str_t *strs, unsigned int size);

//从请求头中解析出跨容器请求字段值
//参数：head[in], http 请求头
//参数：cross_req_head[out], 获取到的跨容器请求头字段值
//返回值：0；成功， 非0：失败
BONREE_SDK_API int get_cross_req_head_from_head(str_t *head, cross_req_head_t* cross_req_head);

//从请求头中解析出跨容器请求响应头字段值
//参数：head[in], http 响应头
//参数：cross_req_head[out], 获取到的跨容器响应头字段值
//返回值：0；成功， 非0：失败
BONREE_SDK_API int get_cross_resp_head_from_head(str_t *head, cross_req_head_t* cross_req_head);

#ifdef __cplusplus
}
#endif

#endif //_BONREE_SDK_UTILS_STR_UTIL_H_
