#!/usr/bin/env bash
#
# Copyright 2020 bonree.
# All rights reserved.
#
# Uninstall script for Bonree c/c++ SDK agent
#

canonicalNameOfThisFile=`readlink -f "$0"`
containingDir=`dirname "$canonicalNameOfThisFile"`
agentVersionId="0"

if [ -f ${containingDir}/version.txt ]; then
   agentVersionId=$(cat ${containingDir}/version.txt)
fi

echo "Uninstall script for Bonree c/c++ SDK Agent ${agentVersionId}."

# remove ld file
ldconfDir="/etc/ld.so.conf.d"
ldconfFile="${ldconfDir}/bonree_sdk_native.conf"

if [ -f ${ldconfFile} ]; then
    echo "remove ${ldconfFile}..."
    rm -rf ${ldconfFile}
    [ -x `which ldconfig` ] && ldconfig
fi

echo -e "\033[;32;1mUninstall success \033[m"