/*
Copyright (c) AppDynamics, Inc., and its affiliates
2015
All Rights Reserved
*/
'use strict';

function System(agent) {
  this.agent = agent;

  this.hasHrtime = true;
  this.timekit = undefined;
}
exports.System = System;


System.prototype.init = function() {
  var self = this;

  // make sure hrtime is available
  self.hasHrtime = process.hasOwnProperty('hrtime');
};


System.prototype.hrtime = function() {
  if(this.hasHrtime){
    var ht = process.hrtime();
    return ht[0] * 1000000 + Math.round(ht[1] / 1000);
  }
  else {
    return Date.now() * 1000;
  }
};
