'use strict';

function AsyncHook(agent) {
    this.agent = agent;
    this.baseHook = agent.baseHook;
    this.packages = ['async'];
}
exports.AsyncHook = AsyncHook;

var syncMethods = [
    'join',
    'reject',
    'defer',
    'isPromiseLike',
    'all',
    'settle',
    'any',
    'some'
];

var asyncMethods = [
    'whilst',
    'until',
    'queue',
    'apply',
    'concat',
    'nextTick',
    'each',
    'eachSeries',
    'eachLimit',
    'forEachOf',
    'map',
    'mapLimit',
    'filter',
    'filterSeries',
    'reject',
    'rejectSeries',
    'reduce',
    'reduceRight',
    'detect',
    'detectSeries',
    'sortBy',
    'compose'
];

var AsyncMethodsWithObjOrArr = [
    'series',
    'parallel',
    'waterfall',
    'iterator'
];

AsyncHook.prototype.attach = function(obj) {
    var baseHook = this.baseHook;
    syncMethods.forEach(function(method) {
        baseHook.wrapSyncMethod(obj, 'async.' + method);
    });
    asyncMethods.forEach(function(method) {
        baseHook.wrapAllCallback(obj, 'async.' + method);
    });

    AsyncMethodsWithObjOrArr.forEach(function(method) {
        baseHook.wrapWithTaskObjOrArr(obj, 'async.' + method);
    });
    baseHook.wrapWithTaskObj(obj, 'async.auto');
};
