'use strict';
function AnyPromiseHook(agent)
{
    this.agent = agent;
    this.packages = ['any-promise'];
}

exports.AnyPromiseHook = AnyPromiseHook;

var syncMethods = [
    'resolve',
    'reject',
    'all',
    'race'
];

var asyncMethods = [
    'then',
    'catch'
];

AnyPromiseHook.prototype.attach = function (obj) {
    var self = this;
    var localBaseHook = self.agent.baseHook;

    syncMethods.forEach(function(method) {
        localBaseHook.wrapSyncMethod(obj, 'Promise.' + method);
    });

    asyncMethods.forEach(function(method) {
        localBaseHook.wrapAsyncMethod(obj.prototype, 'Promise.' + method);
    });
};