'use strict';

function DnsHook(agent) {
    this.agent = agent;
    this.baseHook = agent.baseHook;
    this.packages = ['dns'];
}

exports.DnsHook = DnsHook;

var syncMethods = [
    'getServers',
    'setServers'
];

var asyncMethods = [
    'lookup',
    'lookupService',
    'resolve',
    'resolve4',
    'resolve6',
    'resolveCname',
    'resolveMx',
    'resolveNaptr',
    'resolveNs',
    'resolvePtr',
    'resolveSoa',
    'resolveSrv',
    'resolveTxt',
    'resolveAny',
    'reverse'
];

DnsHook.prototype.attach = function(obj, moduleName) {
    var self = this;
    self.agent.logger.debug('hooking ' + moduleName + ' on require');
    var baseHook = this.baseHook;

    syncMethods.forEach(function (value) {
        baseHook.wrapSyncMethod(obj, 'dns.' + value);
    });
    baseHook.wrapSyncMethod(obj.Resolver.prototype, 'dns.Resolver');

    asyncMethods.forEach(function (value) {
        baseHook.wrapAsyncMethod(obj, 'dns.' + value);
    });
};