'use strict';

function EventHook(agent) {
    this.agent = agent;
    this.baseHook = agent.baseHook;
    this.packages = ['events'];
}

exports.EventHook = EventHook;

var syncMethods = [
    'eventNames',
    'getMaxListeners',
    'listenerCount',
    'listeners',
    'removeAllListeners',
    'removeListener',
    'setMaxListeners'
];

var asyncMethods = [
    'addListener',
    'prependListener',
    'prependOnceListener'
];

EventHook.prototype.attach = function(obj) {
    var baseHook = this.baseHook;
    syncMethods.forEach(function (value) {
        baseHook.wrapSyncMethod(obj, 'EventEmitter.' + value);
    });
    asyncMethods.forEach(function (value) {
        baseHook.wrapAsyncMethod(obj, 'EventEmitter.' + value);
    });
};