'use strict';

function FsHook(agent) {
    this.agent = agent;
    this.baseHook = agent.baseHook;
    this.packages = ['fs'];
}

exports.FsHook = FsHook;

var syncMethods = [
    'accessSync',
    'appendFileSync',
    'chmodSync',
    'chownSync',
    'closeSync',
    'copyFileSync',
    'createReadStream',
    'createWriteStream',
    'existsSync',
    'fchmodSync',
    'fchownSync',
    'fdatasyncSync',
    'fstatSync',
    'fsyncSync',
    'ftruncateSync',
    'futimesSync',
    'lchmodSync',
    'lchownSync',
    'linkSync',
    'lstatSync',
    'mkdirSync',
    'mkdtempSync',
    'openSync',
    'readdirSync',
    'readlinkSync',
    'readSync',
    'realpathSync',
    'renameSync',
    'rmdirSync',
    'statSync',
    'symlinkSync',
    'truncateSync',
    'unlinkSync',
    'utimesSync',
    'readFileSync',
    'writeFileSync'
    //'writeSync'
];
var asyncMethods = [
    'access',
    'appendFile',
    'chmod',
    'chown',
    'close',
    'copyFile',
    'exists',
    'fchmod',
    'readFile',
    'writeFile',
    'fchown',
    'fdatasync',
    'fstat',
    'fsync',
    'ftruncate',
    'futimes',
    'lchmod',
    'lchown',
    'link',
    'lstat',
    'mkdir',
    'mkdtemp',
    'open',
    'read',
    'readdir',
    'readlink',
    'realpath',
    'rename',
    'rmdir',
    'stat',
    'symlink',
    'truncate',
    'unlink',
    'utimes',
    'watch',
    'watchFile',
    'write'
];


FsHook.prototype.attach = function(obj, moduleName) {
    var self = this;

    var baseHook = this.baseHook;
    /*syncMethods.forEach(function(value) {
        baseHook.wrapSyncMethod(obj, 'fs.' + value);
    });*/
    asyncMethods.forEach(function (value) {
        baseHook.wrapAsyncMethod(obj, 'fs.' + value , null, function (obj,args,locals){
            var txn = self.agent.tracer.getTransaction();
            if(!txn) return;
        });
    });

    baseHook.wrapSyncMethod(obj.FileReadStream.prototype, 'FileReadStream._read');

};