'use strict';

function CronHook(agent){
    this.agent=agent;
    this.baseHook = agent.baseHook;
    this.packages = ['cron'];
}

exports.CronHook= CronHook;

var cronTimeSyncMethod=[
    '_verifyParse',
    'sendAt',
    'getTimeout',
    'toString',
    'toJSON',
    '_getNextDateFrom',
    '_findDST',
    '_wcOrAll',
    '_hasAll',
    '_parse',
    '_parseField'
];

var cronJobAsyncMethod=[
    'addCallback',
];

var cronJobSyncMethod=[
    'start',
    'stop',
    'setTime',
    'nextDate',
    'fireOnTick',

];


CronHook.prototype.attach=function(obj){
    var self=this;
    var baseHook=self.baseHook;
    cronTimeSyncMethod.forEach(function(method){
        baseHook.wrapSyncMethod(obj.CronTime.prototype, 'CronTime.' + method);
    });
    cronJobAsyncMethod.forEach(function(method){
        baseHook.wrapAsyncMethod(obj.CronJob.prototype,'CronJob.'+method);
    });
    cronJobSyncMethod.forEach(function(method){
        baseHook.wrapSyncMethod(obj.CronJob.prototype,'CronJob.'+method);
    });
};



