'use strict';


function EggHook(agent)
{
    this.agent = agent;
    this.packages = ['egg'];
    // this.baseHook = agent.baseHook;
    this.jsConfig=agent.config.config.jsConfig || {
        enable:false
    };
}

exports.EggHook = EggHook;

EggHook.prototype.attach = function (obj, name) {
    var self = this;
    var localBaseHook = self.agent.baseHook;

    if (obj.__bonrAttached__) return;
    obj.__bonrAttached__ = true;

    if (name == 'egg') {
        // localBaseHook.wrapAsyncMethod
        localBaseHook.wrapAsyncMethod(obj.Application.prototype, 'handleRequest', null, function(obj, args) {
            if (args.length < 1) return;
            var txn = self.agent.tracer.getTransaction();
            if(!txn) {
                return;
            }

            txn.component='Egg';
            var ctx = args[0];
            if (!!ctx.app && !!ctx.app.middleware && Array.isArray(ctx.app.middleware)) {
                var locals = {};
                locals.wrapBefore = function(obj, args) {
                    var argNum = args.length;
                    if (argNum < 1) return;

                    if (typeof args[argNum - 1] === 'function') {
                        args[argNum - 1] = localBaseHook.bindFunction(args[argNum - 1], null, true);
                        args[argNum - 1]._txn = txn;
                    }
                };
                for (var i = 0, l = ctx.app.middleware.length; i < l; i++) {
                    if (ctx.app.middleware[i].name.length > 0) continue;
                    ctx.app.middleware[i] = localBaseHook.bindFunction(ctx.app.middleware[i], null, true, locals);
                }
                ctx._txn = txn;
            }

            self.agent.wrap.before(ctx.res,'end',function(obj,args){
                if(self.agent.config.jsInjectEnabled()){
                    var chunk=args[0];
                    var pattern =  /^(<!DOCTYPE html>)\1*$/m;
                    var flag=pattern.test(chunk);
                    var jsString="<script>" + self.agent.config.config.injectJsConfig.injectJs + "</script>";
                    if(flag){
                        if(chunk.indexOf(jsString)!==-1) return;
                        var insert = self.agent.config.config.js_inject_pos==1 ? "</head>" : "<script>";
                        var index=chunk.indexOf(insert);
                        if(index==-1){
                            index=chunk.indexOf("</head>");
                        }
                        var result=chunk.slice(0,index)+jsString+chunk.slice(index);
                        args[0]=result;
                        ctx.body=args[0];
                    }
                }
            });
        });
    }
};


