'use strict';

function ExpressHook(agent)
{
    this.agent = agent;
    this.packages = ['express'];
    this.connections = undefined;
    this.baseHook = agent.baseHook;
    this.jsConfig=agent.config.config.jsConfig || {
        enable:false
    };
}

exports.ExpressHook = ExpressHook;

ExpressHook.prototype.attach = function (obj) {
    var self = this;
    var localBaseHook = self.baseHook;

    if(obj.__bonrAttached__) return;
    obj.__bonrAttached__ = true;
    var repeatNum = 0;

    localBaseHook.wrapAsyncMethod(obj.Router, 'process_params', null,function (obj,args,locals) {
        var txn = self.agent.tracer.getTransaction();
        if (!txn) {
          if (args.length > 2) txn = args[2]._txn;
        } else if (args.length > 2) {
          args[2]._txn = txn;
        }
        if (!!txn && !txn._segRepeatNum) txn._segRepeatNum = 1;
        else locals.reuseParent = true;
        if(!!txn) txn.component='Express';
        var Layer = args[0];
        if(Layer&& Layer.constructor)
        {
            if(Layer.__bonrAttached__) return;
            //Layer.__bonrAttached__ = true;
            if (repeatNum >= obj.stack.length - 1) {
                Layer.handle = localBaseHook.bindFunction(Layer.handle);
            }
            localBaseHook.wrapAsyncMethod(Object.getPrototypeOf(Layer), 'handle_request', null, function (obj,args,locals) {
                var txn = self.agent.tracer.getTransaction();
                if (!txn) {
                    return;
                }
                // if (!txn) {
                //   txn = args[0]._txn;
                //   if (!!txn) locals.parentSegment = txn.getActiveSegment();
                // }
                if (!!txn) {
                  if (txn._segRepeatNum > 1) locals.reuseParent = true;
                  else txn._segRepeatNum++;
                }
                var res=args[1];
                self.agent.wrap.before(res,'send',function(obj,args){
                    if(self.agent.config.jsInjectEnabled()){
                        var chunk=args[0];
                        var pattern =  /^(<!DOCTYPE html>)\1*$/m;
                        var flag=pattern.test(chunk);
                        if(flag){
                            var jsString="<script>"+ self.agent.config.config.injectJsConfig.injectJs + "</script>";
                            if(chunk.indexOf(jsString)!==-1) return;
                            var insert=self.agent.config.config.js_inject_pos==1?"</head>":"<script>";
                            var index=chunk.indexOf(insert);
                            if(index==-1){
                                index=chunk.indexOf("</head>");
                            }
                            var result=chunk.slice(0,index)+jsString+chunk.slice(index);
                            args[0]=result;
                        }
                    }

                });

           //      if(obj.__bonrAttached__) return;
                 obj.__bonrAttached__ = true;
                self.agent.wrap.callback(args,2,function (obj,args) {
                    if(args.length)
                    {
                        var err = args[0];
                        if(!err) return;
                        if(err) err.name='express';
                        if (!!txn && !txn.bException) txn.addException(err);
                    }
                });
            }, null);
        }
    },null);
};
