'use strict';

function GlobalHook(agent) {
    this.agent = agent;
    this.baseHook = agent.baseHook;
}
exports.GlobalHook = GlobalHook;

var syncMethods = [
    'clearImmediate',
    'clearInterval',
    'clearTimeout'
];

var asyncMethods = [
    'setTimeout',
    'setInterval',
    'setImmediate'
];

GlobalHook.prototype.attach = function(obj) {
    var baseHook = this.baseHook;
    syncMethods.forEach(function (value) {
        baseHook.wrapSyncMethod(obj, 'global.' + value);
    });
    asyncMethods.forEach(function (value) {
        baseHook.wrapAsyncMethod(obj, 'global.' + value, 0);
    });
};