'use strict';

function HapiHook(agent) {
    this.agent = agent;
    this.baseHook = agent.baseHook;
    this.packages = ['hapi'];
    this.jsConfig=agent.config.config.jsConfig || {
        enable:false
    };
}
exports.HapiHook = HapiHook;

HapiHook.prototype.attach = function(obj) {
    var fs=require('fs');
    var self = this;
    var orig = obj.Server;
    var newServer = function() {
        var ret = orig.apply(null, arguments);
        var queue = ret._core.queue;
        self.baseHook.wrapAsyncMethod(Object.getPrototypeOf(queue),'Queue.add',null, function(obj, args) {
            if (!!args && !!args[0]) {
                var request = args[0];
                self.baseHook.wrapAsyncMethod(Object.getPrototypeOf(request),'Request._setResponse',null,function(obj,args){
                    if(!!args && args[0]){
                        var response = args[0];
                        var js = self.agent.config.config.injectJsConfig.injectJs;
                        var jsString="<script>"+js+"</script>";
                        var path;
                        if(!!response.source.file && !!response.source.file.path){
                            path=response.source.file.path;
                        }
                        var pattern=/^.+\.html$/ig;
                        if(self.agent.config.jsInjectEnabled()){
                            if(pattern.test(path)){
                                fs.readFile(path,function(err,data){
                                    if(data.indexOf(jsString)!==-1) return;
                                    // var head="<head>";
                                    // var index=data.indexOf(head)+head.length;
                                    // var result=data.slice(0,index)+'\n'+jsString+data.slice(index);
                                    // fs.writeFile(path,result,function(err){
                                    //     if(err) return;
                                    // })
                                    var insert=self.agent.config.config.js_inject_pos==1?"</head>":"<script>";
                                    var index=data.indexOf(insert);
                                    if(index==-1){
                                        index=data.indexOf("</head>");
                                    }
                                    var result=data.slice(0,index)+jsString+'\n'+data.slice(index);
                                    fs.writeFile(path,result,function(err){
                                        if(err) return err;
                                    });
                                });
                            }
                        }else{
                            if(pattern.test(path)){
                                fs.readFile(path,function(err,data){
                                    if(data.indexOf(jsString)!==-1){
                                        var index=data.indexOf(jsString);
                                        var result=data.slice(0,index)+data.slice(index+jsString.length+1);
                                        fs.writeFile(path,result,function(err){
                                            if(err) return err;
                                        });
                                    }
                                });
                            }
                        }
                    }
                });
                self.baseHook.wrapAsyncMethod(Object.getPrototypeOf(request), 'Request._execute');
            }
        });
        return ret;
    };
    for (var property in orig) {
        if (orig.hasOwnProperty(property)) {
            newServer[property] = orig[property];
        }
    }
    if (!!orig.prototype) newServer.prototype = orig.prototype;
    if (!!orig.exports) newServer.exports = orig.exports;
    obj.Server = newServer();

};
