'use strict';
function Koa2Hook(agent)
{
    this.agent = agent;
    this.packages = ['koa'];
    this.jsConfig=agent.config.config.jsConfig || {
        enable:false
    };
}

exports.Koa2Hook = Koa2Hook;


Koa2Hook.prototype.attach = function (obj, name) {
    var self = this;
    var localBaseHook = self.agent.baseHook;

    if(obj.__bonrAttached__) return;
    obj.__bonrAttached__ = true;

    if (name == 'koa') {
        //This will cause the back end error to be added repeatedly, so annotate it
        /*self.agent.wrap.before(obj.prototype,['onerror'],function (obj,args) {
            var error = args[0];
            if(error)
            {
                var txn = self.agent.tracer.getTransaction();//self.agent.profiler.getTransaction(threadid);
                txn.addException(error);
            }
        });*/
        localBaseHook.wrapAsyncMethod(obj.prototype, 'Application.handleRequest', null, function(obj, args) {
            if (args.length < 1) return;
            var txn = self.agent.tracer.getTransaction();
            if(!txn) {
                return;
            }
            if (txn.component === 'Egg') {
                return;
            }

            txn.component='Koa';
            var ctx = args[0];
            if (!!ctx.app && !!ctx.app.middleware && Array.isArray(ctx.app.middleware)) {
                var locals = {};
                locals.wrapBefore = function(obj, args) {
                    var argNum = args.length;
                    if (argNum < 1) return;

                    if (typeof args[argNum - 1] === 'function') {
                        args[argNum - 1] = localBaseHook.bindFunction(args[argNum - 1], null, true);
                        args[argNum - 1]._txn = txn;
                    }
                };
                for (var i = 0, l = ctx.app.middleware.length; i < l; i++) {
                    if (ctx.app.middleware[i].name.length > 0) continue;
                    ctx.app.middleware[i] = localBaseHook.bindFunction(ctx.app.middleware[i], null, true, locals);
                }
                ctx._txn = txn;
            }

            self.agent.wrap.before(ctx.res,'end',function(obj,args){
                if(self.agent.config.jsInjectEnabled()){
                    var chunk=args[0];
                    var pattern =  /^(<!DOCTYPE html>)\1*$/m;
                    var flag=pattern.test(chunk);
                    var jsString="<script>" + self.agent.config.config.injectJsConfig.injectJs + "</script>";
                    if(flag){
                        if(chunk.indexOf(jsString)!==-1) return;
                        // var head="<head>";
                        // var index=chunk.indexOf(head)+head.length;
                        // var result=chunk.slice(0,index)+'\n'+jsString+chunk.slice(index);
                        // args[0]=result;
                        // ctx.body=args[0];
                        var insert = self.agent.config.config.js_inject_pos==1 ? "</head>" : "<script>";
                        var index=chunk.indexOf(insert);
                        if(index==-1){
                            index=chunk.indexOf("</head>");
                        }
                        var result=chunk.slice(0,index)+jsString+chunk.slice(index);
                        args[0]=result;
                        ctx.body=args[0];
                    }
                }
            });
        });
    }
};
