'use strict';
function LoopbackMysqlHook(agent) {
  this.agent = agent;
  this.baseHook = agent.baseHook;
  this.packages = ['loopback-connector-mysql'];
}
exports.LoopbackMysqlHook = LoopbackMysqlHook;

LoopbackMysqlHook.prototype.attach = function(obj, name) {
  var self = this;
  var localBaseHook = self.baseHook;
  var tracer = self.agent.tracer;

  if(obj.__bonrAttached__) return;
  obj.__bonrAttached__ = true;

  var mySql = obj.MySQL;
  var methods = ['connect', 'executeSQL'];
  methods.forEach(function(method) {
    localBaseHook.wrapAsyncMethod(mySql.prototype, 'MySQL.'+method, null, function (obj, args, locals) {
      locals.transaction = tracer.getTransaction();
      if (!!locals.transaction) locals.parentSegment = locals.transaction.getActiveSegment();
      locals.wrapBefore = function(obj, args) {
        var error = args[0];
        if(error){
            error.name="loopback-connector-mysql";
            locals.transaction.addException(error);
        }
      };
    });
  });
};

