'use strict';

function LoopbackPgHook(agent) {
  this.agent = agent;
  this.baseHook = agent.baseHook;
  this.packages = ['loopback-connector-postgresql'];
}
exports.LoopbackPgHook = LoopbackPgHook;

LoopbackPgHook.prototype.attach = function(obj, name) {
  var self = this;
  var localBaseHook = self.baseHook;
  var tracer = self.agent.tracer;

  if(obj.__bonrAttached__) return;
  obj.__bonrAttached__ = true;

  localBaseHook.wrapSyncMethod(obj, 'Connector.initialize', null, function(obj, args) {
    var pg = !!args[0] ? args[0].connector : null;
    if (!pg) return;
    var methods = ['connect', 'executeSQL'];
    methods.forEach(function(method) {
      localBaseHook.wrapAsyncMethod(pg, 'PostgreSQL.'+method, null, function (obj, args, locals) {
        locals.transaction = tracer.getTransaction();
        if (!!locals.transaction) locals.parentSegment = locals.transaction.getActiveSegment();
        locals.wrapBefore = function(obj, args) {
          var error = args[0];
          if(error){
              error.name='loopback-connector-postgresql';
              locals.transaction.addException(error);
          }
        };
      });
    });
  });
};

