'use strict';

function LoopbackHook(agent) {
  this.agent = agent;
  this.baseHook = agent.baseHook;
  this.packages = ['loopback','loopback-phase'];
}
exports.LoopbackHook = LoopbackHook;

LoopbackHook.prototype.attach = function(obj, name) {
  var self = this;
  var localBaseHook = self.baseHook;
  //var tracer = self.agent.tracer;

  if (name == 'loopback') {
    if(obj.Application.__bonrAttached__) return;
    obj.Application.__bonrAttached__ = true;
    var appMethod = ['bulkUpdate','changes','checkAccess','checkPoint','count','create','createChangeStream',
        'createUpdates','currentCheckpoint','deleteAll','deleteById','destroyAll','destroyById','diff','exists',
        'find','findById','findLastChange','findOne','findOrCreate','getSourceId','nestRemoting','notifyObserversAround',
        'notifyObserversOf','patchOrCreate','patchOrCreateWithWhere','rectifyAllChanges','rectifyChange','register',
        'remove','removeById','replaceById','replaceOrCreate'];
    var appSubMethod = ['param','render','handle'];

    appMethod.forEach(function(method) {
      localBaseHook.wrapAsyncMethod(obj.Application, 'Application.'+method);
    });
    appSubMethod.forEach(function(method) {
      localBaseHook.wrapAsyncMethod(obj.application, 'application.'+method);
    });

    var checkmethods = ['checkAccess', 'checkAccessForToken', 'checkAccessForContext'];
    checkmethods.forEach(function (method) {
      localBaseHook.wrapAsyncMethod(obj.ACL, 'ACL.'+method);
    });
  } else if (name == 'loopback-phase') {
    if(obj.Phase.__bonrAttached__) return;
    obj.Phase.__bonrAttached__ = true;
    localBaseHook.wrapAsyncMethod(obj.Phase.prototype, 'Phase.run');
  }

};

