'use strict';
var util = require('util');
function NuxtHook(agent)
{
  this.agent = agent;
  this.packages = ['nuxt'];
  this.baseHook = agent.baseHook;
}

exports.NuxtHook = NuxtHook;

NuxtHook.prototype.attach = function(obj) {
  var self = this;
  var localBaseHook = self.baseHook;

  if (obj.__bonrAttached__) return;
  obj.__bonrAttached__ = true;
  var wrap = self.agent.wrap;


  //nuxt2.x
  wrap.aroundpromise(obj, 'loadNuxt',function (ob,args,locals){},function (obj,args,ret,locals) {

    localBaseHook.wrapAsyncMethod(ret.data, 'next.render',null,function (obj,args,locals) {

       localBaseHook.wrapAsyncMethod(obj, 'render.use',null,function (obj,args,locals) {

          args[1] = localBaseHook.bindFunction(args[1],null,true,locals);

       },null);
      localBaseHook.wrapAsyncMethod(obj, 'render.handle',null,function (obj,args,locals) {
        var txn = self.agent.tracer.getTransaction();
        if(!!txn && !txn.component) txn.component='Nuxt';
        },null);
    });
  })

  //nuxt1.x
  if(!!obj.Renderer) {

      localBaseHook.wrapAsyncMethod(obj.Renderer.prototype,'Renderer.useMiddleware', null,function(obj,args,locals){

      localBaseHook.wrapAsyncMethod(obj.app, 'connect.use', null,function (obj,args,locals) {

        args[1] = localBaseHook.bindFunction(args[1],null,true,locals);
      },null);

      localBaseHook.wrapAsyncMethod(obj.app, 'connect.handle',null,function (obj,args,locals) {
          var txn = self.agent.tracer.getTransaction();
          if(!!txn && !txn.component) txn.component='Nuxt';
        }, null);

    }, function (obj, args, ret, locals) {

    });
  }

};

NuxtHook.prototype.hookConstructor = function(obj) {
  var self = this;
  var orig = obj;
  function NuxtWithHook() {
    var ret = orig.apply(this, arguments);
    return ret;
  }
  for (var attr in orig) {
    NuxtWithHook[attr] = orig[attr];
  }
  return NuxtWithHook;
};
