'use strict';

function QHook(agent) {
    this.agent = agent;
    this.baseHook = agent.baseHook;
    this.packages = ['q'];
}
exports.QHook = QHook;

var syncMethods = [
    'delay',
    'defer',
    'all'
];

var asyncMethods = [
    'when',
    'promise',
    'spawn',
    'async',
    'tap'
];

var promiseSyncMethods = [
    'get',
    'post',
    'keys',
    'invoke',
    'fbind',
    'fcall',
    'fapply',
    'thenResolve',
    'thenReject',
    'timeout'
];

var promiseAsyncMethods = [
    'then',
    'progress',
    'catch',
    'finally',
    'done',
    'spread'
];

var deferMethods = [
    'reject',
    'resolve',
    'fulfill',
    'notify'
];

QHook.prototype.attach = function(obj) {
    var baseHook = this.baseHook;
    syncMethods.forEach(function(method) {
        if (method == 'defer') {
            baseHook.wrapSyncMethod(obj, 'Q.' + method, null, function(obj, args, ret, locals) {
                deferMethods.forEach(function(defMethod) {
                    baseHook.wrapSyncMethod(ret, 'deferred.' + defMethod);
                });
            });
        } else {
            baseHook.wrapSyncMethod(obj, 'Q.' + method);
        }
    });
    asyncMethods.forEach(function(method) {
        baseHook.wrapAllCallback(obj, 'Q.' + method);
    });

    promiseSyncMethods.forEach(function(method) {
        baseHook.wrapSyncMethod(obj.makePromise.prototype, 'Promise.' + method);
    });
    promiseAsyncMethods.forEach(function(method) {
        baseHook.wrapAllCallback(obj.makePromise.prototype, 'Promise.' + method);
    });
};
