'use strict';
var url = require('url');

var util = require('util');
var remoteBackendName = require('../models/exitcall').remoteBackendName;
function RequestHook(agent)
{
    this.agent = agent;
    this.packages = ['request'];
    this.baseHook = agent.baseHook;
}

var asyncMethods = [
    'get',
    'post',
    'del',
    'put'
];

exports.RequestHook = RequestHook;

RequestHook.prototype.attach = function(obj) {
    var self = this;
    var localBaseHook = self.baseHook;

    if(obj.__bonrAttached__) return;
    obj.__bonrAttached__ = true;

    asyncMethods.forEach(function(method) {
        localBaseHook.wrapAsyncMethod(obj, 'request.'+method);
    });
};


// RequestHook.prototype.setHttpDefaults = function(locals, spec) {
//     if(typeof(spec) === 'string') {
//         locals.opts = url.parse(spec);
//         if (locals.opts.protocol === 'https:'){
//             locals.opts.protocol = 'https';
//         }
//         if (locals.opts.protocol === 'http:'){
//             locals.opts.protocol = 'http';
//         }
//     }
//     else {
//         locals.opts = spec;
//     }
//
//     locals.opts.hostname = locals.opts.hostname || locals.opts.host || 'localhost';
//     locals.opts.port = locals.opts.port || (locals.opts.protocol === 'https' ? 443 : 80);
//     locals.opts.path = locals.opts.pathname || locals.opts.path || '/';
// };

/*
RequestHook.prototype.attach = function(obj) {
    var self = this;
    var localBaseHook = self.baseHook;

    if(obj.__bonrAttached__) return;
    obj.__bonrAttached__ = true;

    asyncMethods.forEach(function(method) {
        localBaseHook.wrapAsyncMethod(obj, 'request.'+method, null, function(obj, args, locals){
            var txn = self.agent.tracer.getTransaction();
            locals.time = self.agent.profiler.time();
            self.setHttpDefaults(locals, args[0]);

            var supportedProperties = {
                'HOST': locals.opts.hostname,
                'PORT': locals.opts.port,
                'URL': args[0],
                'TYPE': locals.opts.protocol,
                'PATH': locals.opts.path,
                'METHOD': method,
            };
            var backendNamePath = remoteBackendName(self.agent,url.parse(supportedProperties.URL).pathname);
            locals.exitCall = self.agent.profiler.createExitCall(locals.time, {
                backendType: 'BACKEND_TYPE_HTTP',
                name: args[0],
                host: supportedProperties.HOST,
                port: supportedProperties.PORT,
                operation: backendNamePath,
                url: supportedProperties.URL,
                connType: supportedProperties.TYPE,
                is_async: false
            }, txn);
            if(!locals.time.done()) return;
            self.agent.profiler.addExitCall(locals.time, null, locals.exitCall, txn);

            self.agent.wrap.callback(args,-1,function (obj,args) {
                if(args.length)
                {
                    var err = args[0];
                    if (!!txn && !!err){
                        txn.addException(err);
                    }
                }
            });
        }, null);
    });
}
*/

//
// RequestHook.prototype.hookConstructor = function(obj) {
//     var self = this;
//     var baseHook = this.baseHook;
//     var orig = obj;
//     function RequestWithHook() {
//         var request_local = {};
//          var locals ={};
//             var txn = self.agent.tracer.getTransaction();
//             locals.time = self.agent.profiler.time();
//             self.setHttpDefaults(locals, arguments[0]);
//
//             var supportedProperties = {
//                 'HOST': locals.opts.hostname,
//                 'PORT': locals.opts.port,
//                 'URL': arguments[0],
//                 'TYPE': locals.opts.protocol,
//                 'PATH': locals.opts.path,
//             };
//             var backendNamePath = remoteBackendName(self.agent,url.parse(supportedProperties.URL).pathname);
//             locals.exitCall = self.agent.profiler.createExitCall(locals.time, {
//                 backendType: 201,
//                 name: arguments[0],
//                 host: supportedProperties.HOST,
//                 port: supportedProperties.PORT,
//                 operation: backendNamePath,
//                 url: supportedProperties.URL,
//                 connType: supportedProperties.TYPE,
//                 is_async: false
//             }, txn);
//
//             self.agent.wrap.callback(arguments,-1,function (obj,args) {
//                 if(!locals.time.done()) return;
//                 self.agent.profiler.addExitCall(locals.time, null, locals.exitCall, txn);
//                 if (!txn._rpcs) txn._rpcs = [];
//                 if(txn._traceHeader){
//                     var traceHeader=new TraceHeader();
//                     traceHeader.clone(txn._traceHeader);
//                     traceHeader.setRpcId();
//
//                     txn._rpcs.push({
//                         rpcId:traceHeader.rpcId(),beType:'BACKEND_TYPE_HTTP',classMethod:{
//                             className:'http',
//                             methodName:obj.method,
//                         },
//                         startTimeStamp:txn.ts,
//                         endTimeStamp:0,
//                         async:false,
//                         ueType:txn.userExperience()
//                     });
//                 }
//
//                 if(args.length)
//                 {
//                     var err = args[0];
//                     if (!!txn && !!err){
//                         txn.addException(err);
//                     }
//                 }
//             });
//
//        // var ret = baseHook.bindFunction(obj, null, true, request_local);
//         orig.apply(this, arguments);
//     }
//     for (var attr in orig) {
//         RequestWithHook[attr] = orig[attr];
//     }
//
//     return RequestWithHook;
// }
