'use strict';

function WhenHook(agent) {
    this.agent = agent;
    this.baseHook = agent.baseHook;
    this.packages = ['when'];
}
exports.WhenHook = WhenHook;

var syncMethods = [
    'resolve',
    'join',
    'reject',
    'defer',
    'isPromiseLike',
    'all',
    'settle',
    'any',
    'some'
];

var asyncMethods = [
    'try',
    'lift',
    'promise',
    'map',
    'filter',
    'reduce',
    'reduceRight',
    'iterate',
    'unfold'
];

var promiseSyncMethods = [
    'fold',
    'yield',
    'else',
    'delay',
    'timeout',
    'inspect',
    'with'
];

var promiseAsyncMethods = [
    'done',
    'then',
    'spread',
    'catch',
    'finally',
    'tap',
    'progress'
];

var deferMethods = [
    'reject',
    'resolve',
    'fulfill',
    'notify'
];

WhenHook.prototype.attach = function(obj) {
    var baseHook = this.baseHook;
    syncMethods.forEach(function(method) {
        if (method == 'defer') {
            baseHook.wrapSyncMethod(obj, 'when.' + method, null, function(obj, args, ret, locals) {
                deferMethods.forEach(function(defMethod) {
                    baseHook.wrapSyncMethod(ret, 'deferred.' + defMethod);
                });
            });
        } else {
            baseHook.wrapSyncMethod(obj, 'when.' + method);
        }
    });
    asyncMethods.forEach(function(method) {
        baseHook.wrapAllCallback(obj, 'when.' + method);
    });

    promiseSyncMethods.forEach(function(method) {
        baseHook.wrapSyncMethod(obj.Promise.prototype, 'Promise.' + method);
    });
    promiseAsyncMethods.forEach(function(method) {
        baseHook.wrapAllCallback(obj.Promise.prototype, 'Promise.' + method);
    });
};
