var AsyncHooks = require('async_hooks');

function AsyncTracer(agent) {
  this.agent=agent;
  this.txnId = -1;
  this.currentUid = -1;
  this.stack = new Map();
  this.stack.set(-1, -1);
}

module.exports = AsyncTracer;

AsyncTracer.prototype.enableAsyncHooks = function() {
  var self = this;

  function init(id, type, triggerId, resource) {
      const txnId = self.stack.get(triggerId || self.currentUid);
      self.stack.set(id, txnId);
  }
  function before(uid) {
      self.currentUid = uid;
  }
  function after(uid) {
      self.currentUid = -1;
  }
  function destroy(uid) {
      self.stack.delete(uid);
  }

  const hook = AsyncHooks.createHook({init, before, after, destroy});
  
  hook.enable();
};

AsyncTracer.prototype.setTransactionId = function(txnId) {
    this.stack.set(this.currentUid, txnId);
};

AsyncTracer.prototype.getTransactionId = function() {
  return this.stack.get(this.currentUid);
};
