var AsyncHooks=require('@creditkarma/async-hooks');
function CoTracer(agent){
    this.agent=agent;
    this.txnId = -1;
    this.currentUid = -1;
    this.stack = new Map();
    this.stack.set(-1, -1);
}

module.exports=CoTracer;

CoTracer.prototype.enableAsyncHooks=function(){
    var self = this;

    function init(id, type, triggerId, resource) {
        var txnId = self.stack.get(triggerId || self.currentUid);
        self.stack.set(id, txnId);
    }
    function before(uid) {
        self.currentUid = uid;
    }
    function after(uid) {
        self.currentUid = -1;
    }
    function destroy(uid) {
        self.stack.delete(uid);
    }
    var  hook = AsyncHooks.createHook({init, before, after, destroy});
    hook.enable();
    // var versionArr=process.version.split('.');
    // if(versionArr[0]=="v4" && parseInt(versionArr[1])>=5){
    //     AsyncHooks.setupHooks({
    //         init:init,
    //         pre:before,
    //         post:after,
    //         destroy:destroy
    //     });
    // }else{
    //     AsyncHooks.setupHooks(init,before,after,destroy);
    // }
    // AsyncHooks.enable();
};

CoTracer.prototype.setTransactionId = function(txnId) {
    this.stack.set(this.currentUid, txnId);
};

CoTracer.prototype.getTransactionId = function() {
    return this.stack.get(this.currentUid);
};