'use strict';
var ERROR_TYPE = require("../common/constant").ErrorType;
var ERROR_TYPE_STR = require("../common/constant").ErrorTypeStr;


function BRError() {
    this.error = undefined;
    this.errorType = undefined;
    this.errorTypeStr = undefined;
    this.errName = undefined;
    this.timeStamp = undefined;
    this.errSummary = undefined;
    this.errorDetails = undefined;

}


BRError.prototype.prepareErrorData= function (desc) {
    var self = this;
    return {
        timeStamp: self.timeStamp,
        errorType: self.errorType,
        errorSumary: desc || self.errName,
        errorDetails: self.error.stack.toString(),
        errorName: self.errName,
        bt:self.bt,
        url:self.url,
        parentBT:self.parentBT,
        requestGUID:self.requestGUID
    };
};


BRError.prototype.prepareSnapshotError= function () {
    var self = this;
    return {
        timeStamp: self.timeStamp,
        errorSumary: self.errName,
        errorDetails: self.error.stack.toString(),
        errorName: self.errName
    };
};
function CreateException(error,transaction) {
    var brerr = new BRError();
    brerr.error = error;
    brerr.errorType = ERROR_TYPE.ERROR_TYPE_EXCEPTION;
    brerr.errorTypeStr = ERROR_TYPE_STR.ERROR_TYPE_EXCEPTION;
    brerr.timeStamp = Math.round(Date.now());
    brerr.errName = error.name || error.code;
    brerr.errSummary = error.message;
    brerr.errorDetails = error.stack.toString();
    return brerr;
}


function CreateHttpError(statusCode,transaction) {
    var brerr = new BRError();
    brerr.error = new Error('HTTP' + statusCode);
    brerr.errorType = ERROR_TYPE.ERROR_TYPE_HTTP;
    brerr.errorTypeStr = ERROR_TYPE_STR.ERROR_TYPE_HTTP;
    brerr.errName = 'HTTP' + statusCode;
    brerr.timeStamp = Math.round(Date.now());
    return brerr;
}

exports.BRError = BRError;
exports.CreateException = CreateException;
exports.CreateHttpError = CreateHttpError;

