"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class AsyncHook {
    constructor(callbacks) {
        this.enabled = false;
        this.callbacks = callbacks;
    }
    init(asyncId, type, triggerAsyncId, resource) {
        if (this.enabled && this.callbacks.init) {
            this.callbacks.init(asyncId, type, triggerAsyncId, resource);
        }
    }
    before(asyncId) {
        if (this.enabled && this.callbacks.before) {
            this.callbacks.before(asyncId);
        }
    }
    after(asyncId) {
        if (this.enabled && this.callbacks.after) {
            this.callbacks.after(asyncId);
        }
    }
    destroy(asyncId) {
        if (this.enabled && this.callbacks.destroy) {
            this.callbacks.destroy(asyncId);
        }
    }
    enable() {
        this.enabled = true;
        return this;
    }
    disable() {
        this.enabled = false;
        return this;
    }
}
exports.AsyncHook = AsyncHook;
//# sourceMappingURL=AsyncHook.js.map