"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const async_hooks_1 = require("./async-hooks");
const async_wrap_1 = require("./async-wrap");
const AsyncHook_1 = require("./AsyncHook");
const Hooks_1 = require("./Hooks");
const logger = require("./logger");
const State_1 = require("./State");
const utils_1 = require("./utils");
const state = new State_1.State();
const hooks = Hooks_1.createHooks(state);
exports.version = require('../../package.json').version;
if (utils_1.packageExists('async_hooks')) {
    async_hooks_1.startAsyncHooks(hooks, state);
}
else {
    async_wrap_1.startAsyncWrap(hooks, state);
}
function createHook(callbacks) {
    const hook = new AsyncHook_1.AsyncHook(callbacks);
    hooks.add(hook);
    return hook;
}
exports.createHook = createHook;
function executionAsyncId() {
    return state.currentId;
}
exports.executionAsyncId = executionAsyncId;
function currentId() {
    logger.warn('DeprecationWarning: async_hooks.currentId is deprecated. Use async_hooks.executionAsyncId instead');
    return executionAsyncId();
}
exports.currentId = currentId;
function triggerAsyncId() {
    return state.parentId;
}
exports.triggerAsyncId = triggerAsyncId;
function triggerId() {
    logger.warn('DeprecationWarning: async_hooks.triggerId is deprecated. Use async_hooks.triggerAsyncId instead');
    return triggerAsyncId();
}
exports.triggerId = triggerId;
//# sourceMappingURL=AsyncHooks.js.map