'use strict';
try {
    var commander = require('commander');
}
catch(err)
{
    console.log("Please install commander.js by \"npm install commander\"");
    process.exit();
}
try{
    var bonree_proxy = require('bonree_bindeps');
}
catch (err)
{
    console.log("Please install bonree_bindeps");
    process.exit();
}
try{
    var bonree_proxy_support = require('bonree_proxy_support');
}
catch (err)
{
    console.log("Please install bonree_proxy_support");
    process.exit();
}
var path = require('path');
var yamlParser = require('js-yaml');
var fs = require('fs');
var child_process = require('child_process');

function generateDir(workDir){
    if(fs.existsSync(workDir)) {
        return false;
    } else {
        var dirArr = workDir.split('/');
        var tempArr = JSON.parse(JSON.stringify(dirArr));
        var tempDir = null;
        if(tempArr.length){
            tempArr.pop();
            tempDir = tempArr.join('/');
            if(fs.existsSync(tempDir)){
                fs.mkdirSync(workDir);
                return true;
            } else {
                generateDir(tempDir);
                return false;
            }
        }
    }
}

commander
    .version('0.0.1')
    .command('startproxy <config>')
    .description('Start bonree proxy with YAML configuration')
    .action(function (config){
        if(!fs.existsSync(config))
        {
            console.log('Configure file does not exist');
            process.exit();
        }
        // var jrepath = path.join(bonree_proxy_support.dir,'bonree_proxy_support','bin','java');
        var proxy_path = path.join(bonree_proxy.dir,'runProxy.sh');
        var workDir = path.dirname(config);
        try {
            var configOpts = yamlParser.safeLoad(fs.readFileSync(config, 'utf8'));
        }catch (err)
        {
            console.log('Failed to parse config file');
            process.exit();
        }
        var appName = configOpts['common']['AgentInfo']['appName'];
        var logDir = configOpts['common']['AgentInfo']['log']['dir'];
        if(logDir!==undefined)
        {
            workDir = logDir;
        }
        if(!fs.existsSync(workDir))
        {
            // fs.mkdirSync(workDir);
            for(var i = 0; i < workDir.split('/').length; i++) {
                generateDir(workDir);
            }
        }
        var args = [];
        args.push('--with-config='+config);
        args.push('--with-log='+path.join(workDir,appName+'.log'))
        process.env['BONREE_HOME'] = workDir;
        console.log(proxy_path);
        console.log(args);
        var child = child_process.spawn(proxy_path,args,{'env':{'BONREE_HOME':workDir},'detached':true});
        console.log('child is running as '+ child.pid);
        process.exit();

    });

commander.parse(process.argv);
