# -*- coding: utf-8 -*-
# Copyright (c) Bonree, Inc., and its affiliates
# 2015
# All Rights Reserved

import logging
import os.path

from Bonree.lib import default_log_formatter

# The following is a very basic logging config which outputs WARNING level logs to stderr.
try:
    logger = logging.getLogger('Bonree')
    level = logging.WARNING
    logger.setLevel(level)
    logger.propagate = False
    handler = logging.StreamHandler()
    handler.setFormatter(default_log_formatter)
    handler.setLevel(level)
    logger.addHandler(handler)
except Exception:
    pass


def get_version_file_name():
    return os.path.join(os.path.dirname(os.path.realpath(__file__)), '../version.txt')


def get_version(version_file_name=None, noisy=True):
    try:
        version = []
        version_file_name = version_file_name or get_version_file_name()

        if not os.path.isfile(version_file_name):
            return 'unknown'

        with open(version_file_name, 'r') as f:
            for line in f:
                version.append(line.strip().split('=')[-1])
                break
    except Exception:
        if noisy:
            logging.getLogger('Bonree.agent').exception("Couldn't parse build info.")
        return 'unknown'

    return ' '.join(version)
