# -*- coding: utf-8 -*-
# Copyright (c) Bonree, Inc., and its affiliates
# 2015
# All Rights Reserved

"""Bootstrap the agent instance.

"""
import os
import sys
import logging
from Bonree import config
from Bonree.lang import imp
from Bonree.agent.core.agent import Agent
from Bonree.logger import configure_logging
from Bonree.agent.interceptor import BT_INTERCEPTORS, add_hook


def get_ucs():
    ucs = 'ucs4' if sys.maxunicode > 65535 else 'ucs2'
    return ucs

_agent = Agent()


def configure(environ=None):
    agent_config = config.parse_environ()
    if environ:
        agent_config.update(config.parse_environ(environ))

    config.merge(agent_config)
    configure_logging()

    return True


def bootstrap(agent=None):
    try:
        if _agent.enabled:
            return _agent
        _agent.start()
        hook = add_hook(_agent)

        _agent.module_interceptor = hook
        return _agent
    except Exception:
        logging.getLogger('Bonree.agent').exception('Error bootstrapping Bonree agent; disabling.')
        return None


def get_agent_instance():
    if _agent is None:
        return bootstrap()
    else:
        return _agent
