
from __future__ import unicode_literals

from Bonree import rule

from Bonree.agent.interceptor.base import ExitCallInterceptor


class CacheInterceptor(ExitCallInterceptor):
    """Base class for cache interceptors.

    Extra Parameters
    -----------------
    vendor : string
        The vendor name of this cache backend e.g. MEMCACHED.

    """
    def __init__(self, agent, cls, vendor):
        super(CacheInterceptor, self).__init__(agent, cls)
        self.vendor = vendor


from .redis import intercept_redis_client
from .memcache import intercept_memcache
from .ssdb import intercept_ssdb

__all__ = ['intercept_redis_client', 'intercept_memcache', 'intercept_ssdb']
