from Bonree.agent.interceptor.base import ThreadEntryPointInterceptor


class ThreadPoolExecutorInterceptor(ThreadEntryPointInterceptor):
    def start_data(self, md, *args, **kwargs):
        btr = self.btr
        if not btr:
            return

        if len(args) >= 2:
            fn = args[1]
            md.args[1] = self.target_wrapper(fn, btr)
        elif 'fn' in kwargs:
            # It can remove `elif 'fn' in kwargs` code block when agent lowest support is python3.9,
            # because only support position args `fn` in python3.9+
            fn = kwargs['fn']
            md.kwargs['fn'] = self.target_wrapper(fn, btr)


def intercept_futures(agent, mod):
    ThreadPoolExecutorInterceptor(agent, mod.ThreadPoolExecutor).attach('submit')
