"""when g.switch is called. Switches execution to the greenlet g. The callable g.run
that g will run when it starts. After g started, this attribute no longer exists."""
import sys

from Bonree.agent.interceptor.base import ThreadEntryPointInterceptor



class GreenletInterceptor(ThreadEntryPointInterceptor):
    def start_data(self, md, instance, *args, **kwargs):
        btr = self.btr
        if not btr:
            return
        try:
            instance.run = self.target_wrapper(instance.run, btr)
        except AttributeError:
            pass


def intercept_greenlet(agent, mod):

    class greenlet(mod.greenlet):
        def switch(self, *args, **kwargs):
            return super(greenlet, self).switch(*args, **kwargs)

    mod.greenlet = greenlet

    GreenletInterceptor(agent, mod.greenlet).attach('switch')

