# Copyright (c) Bonree, Inc., and its affiliates
# 2018
# All Rights Reserved

"""Interceptor for APIStar framework.

"""
from __future__ import unicode_literals
from Bonree.agent.interceptor.frameworks import ExitPointInterceptor
from Bonree.agent.interceptor.frameworks.wsgi import WSGIInterceptor
from Bonree.config import is_content_type, getgetJsConfigJs


class ApiStarInterceptor(ExitPointInterceptor):

    def end_data(self, md, inj, funcs, state):
        btr = self.btr
        if not btr:
            return

        # request
        # environ = state.get('environ', None)
        # request = environ.get('werkzeug.request', None) if environ else None
        # content_type = environ.get('CONTENT_TYPE', None) if environ else None
        # if is_content_type(content_type):
        #     btr.request_content = request.data

        # response
        response = state.get('response', None)
        content_type = response.media_type if response else None
        if content_type and 'text/html' in content_type and getgetJsConfigJs():
            content = md.response[0]
            if isinstance(content, bytes):
                content = content.decode()
                content = self.inject_js_code(content)
                md.response[0] = content.encode()
        # if is_content_type(content_type):
        #     btr.response_content = response.content if response else None

APISTAR_SUPPORT = False

def intercept_apistar_request(agent, mod):
    if APISTAR_SUPPORT:
        ApiStarInterceptor(agent, mod.Injector).attach('run')


def intercept_APIStar_ASGItoWSGIAdapter(agent, mod):
    if APISTAR_SUPPORT:
        WSGIInterceptor(agent, mod.ASGItoWSGIAdapter).attach('__call__')


def intercept_APIStar(agent, mod):
    global APISTAR_SUPPORT
    if hasattr(mod, '__version__') and mod.__version__ < '0.6':
        APISTAR_SUPPORT = True
        WSGIInterceptor(agent, mod.App).attach('__call__')