from Bonree.agent.interceptor.base import EntryPointInterceptor
from Bonree.agent.interceptor.frameworks import ExitPointInterceptor
from Bonree.config import is_content_type


class StarletteResponseInterceptor(EntryPointInterceptor, ExitPointInterceptor):
    def _render(self, method, ins, value):
        with self.log_exceptions():
            btr = self.btr
            if btr:
                content_type = ins.media_type
                if content_type and 'text/html' in content_type:
                    value = self.inject_js_code(value)
                # if is_content_type(content_type):
                #     btr.response_content = value
        return method(ins, value)


def intercept_starlette(agent, mod):
    from Bonree.agent.interceptor.frameworks.asgi import ASGIInterceptor
    ASGIInterceptor(agent, mod.Starlette).attach('__call__')


def intercept_starlette_response(agent, mod):
    StarletteResponseInterceptor(agent, mod.Response).attach('render', patched_method_name='_render')
