# Copyright (c) Bonree, Inc., and its affiliates
# 2020
# All Rights Reserved


from Bonree.agent.interceptor.base import OnlyStartInterceptor
from Bonree.config import setEnvironIp, setEnvironPort


class UvicornfMakeServerInterceptor(OnlyStartInterceptor):

    def start_data(self, md, *args, **kwargs):
        host = kwargs.get('host', '127.0.0.1')
        port = kwargs.get('port', 8000)
        setEnvironIp(host)
        setEnvironPort([port,])


def intercept_uvicorn(agent, mod):
    UvicornfMakeServerInterceptor(agent, mod).attach('run')
