# Copyright (c) Bonree, Inc., and its affiliates
# 2015
# All Rights Reserved

"""Intercept the Eliot.

"""
from Bonree.agent.interceptor.base import OnlyStartInterceptor
from Bonree.lang import str
from Bonree.config import getTraceEnableAddTraceidToApplog, getPythonEnableDetectEliot


class EliotIntercept(OnlyStartInterceptor):
    def start_data(self, md, logger, dictionary, *args, **kwargs):
        btr = self.btr
        if not btr:
            return
        if not isinstance(dictionary, dict):
            return
        if getTraceEnableAddTraceidToApplog() and btr.cross_svc.trace_id and 'traceId' not in dictionary:
            dictionary['traceId'] = btr.cross_svc.trace_id

        if getPythonEnableDetectEliot():
            message = str(dictionary)
            btr.detect_logs.append({'level': dictionary.get('task_uuid', 'info'), 'logMsg': str(message)})


def intercept_eliot(agent, mod):
    EliotIntercept(agent, mod._output.Logger).attach('write')
