# Copyright (c) Bonree, Inc., and its affiliates
# 2015
# All Rights Reserved

"""Intercept the mysql-connector-python package.

"""

from __future__ import unicode_literals

from .dbapi import DbAPICursorInterceptor, db_api_attach



def get_backend_properties(conn, *args, **kwargs):
    try:
        version = '.'.join(str(x) for x in conn._server_version)
    except AttributeError:
        version = ''

    return conn._host, conn._port, conn._database, version


class MySQLCursorInterceptor(DbAPICursorInterceptor):
    def get_connection(self, cursor):
        return cursor._connection


def intercept_mysql_connector_connection(agent, mod):
    # MySQLConnectionInterceptor(agent, mod.MySQLConnection, MySQLCursorInterceptor, 'MySQL').attach('_open_connection')

    db_api_attach(agent, mod.MySQLConnection, MySQLCursorInterceptor, get_backend_properties, '_open_connection', 'MySQL')
