from Bonree import rule
from Bonree.agent.interceptor.base import ExitCallInterceptor
from Bonree.agent.interceptor.sql.dbapi import DbAPICursorInterceptor, db_api_attach, DbAPIConnectInterceptor
from Bonree.lib import parse_args


def get_backend_properties(conn, *args, **kwargs):
    host = args[0] if len(args) > 0 else kwargs.get('host', 'localhost')
    port = args[1] if len(args) > 1 else kwargs.get('port', '0')
    database = args[3] if len(args) > 3 else kwargs.get('database', 'default')
    return host, port, database, ''


class PyhiveCursorInterceptor(DbAPICursorInterceptor):
    def get_connection(self, cursor):
        return cursor._connection


def intercept_pyhive_connections(agent, mod):
    db_api_attach(agent, mod.Connection, PyhiveCursorInterceptor, get_backend_properties, '__init__', 'hive')
