# Copyright (c) Bonree, Inc., and its affiliates
# 2015
# All Rights Reserved

"""Intercept the pymysql package.

"""

from __future__ import unicode_literals

from .dbapi import DbAPICursorInterceptor, db_api_attach
from Bonree.lang import str


def get_backend_properties(conn, *args, **kwargs):
    try:
        version = conn.server_version
    except AttributeError:
        version = ''
    return conn.host, conn.port, str(conn.db), version


class PymysqlCursorInterceptor(DbAPICursorInterceptor):
    def get_connection(self, cursor):
        return cursor.connection


def intercept_pymysql_connections(agent, mod):
    # PymysqlConnectionInterceptor(agent, mod.Connection, PymysqlCursorInterceptor, 'MySQL').attach('connect')

    db_api_attach(agent, mod.Connection, PymysqlCursorInterceptor, get_backend_properties, 'connect', 'MySQL')


