def common_name(vendor=None, issql=False):
    if issql:
        return '{DATABASE}-{VENDOR}-{HOST}'

    if not vendor:
        return '{VENDOR}-{HOST}:{PORT}'
    elif vendor.lower() == 'producer' or vendor.lower() == 'consumer':
        return vendor.title() + '-{HOST}'
    else:
        vendor = vendor_conversion(vendor)
        return vendor + '-{HOST}:{PORT}'

common_database_mq = 'MQ'

def url_conversion(backend_name, host='', port=''):
    backend_name = backend_name.lower()
    if port == '':
        return backend_name + '://' + str(host)
    return backend_name + '://' + str(host) + ':' + str(port)

def url_sql_conversion(backend_name, host, port, dbname):
    backend_name = backend_name.lower()
    if not isinstance(dbname, str):
        dbname = dbname.decode()
    return backend_name + '://' + str(host) + ':' + str(port) + '/' + dbname


def vendor_conversion(vendor):
    vendor = vendor.lower()
    if vendor.endswith('mq'):
        return vendor[:-2].title() + 'MQ'
    elif vendor.endswith('sql'):
        return vendor[:-3].title() + 'SQL'
    elif vendor in ['ssdb', 'grpc', 'memcached']:
        return vendor.upper()
    else:
        return vendor.title()


def connType_conversion(vendor):
    return vendor.lower()


def peer_address_conversion(address='', ip='', port=''):
    if address == '':
        return ip + ':' + str(port)

    count = address.count('/')
    if count == 0:
        return address + '://' + ip + ':' + str(port)
    elif count == 3:
        address_list =  address.split('/')
        return address_list[0] + '//' + address_list[2]
    else:
        return address

def url_del_parameter(url):
    url = str(url)
    return url.split('?')[0]
