import unittest
import Bonree
from kombu.transport import librabbitmq
from kombu import Connection
from Bonree.agent.interceptor.cache import rabbitmq as agent_rabbitmq
from Bonree.agent import Agent
from Bonree.agent.models.exitcalls import ExitCall, Backend
from Bonree.agent.models import transactions


class TestRabbitmq(unittest.TestCase):

    @classmethod
    def setUpClass(cls):
        cls.agent = Agent()
        cls.agent.start()
        cls.agent.enable = True
        Bonree.agent.bootstrap()
        cls.btr = cls.agent.start_transaction_request(transactions.ENTRY_PYTHON_WSGI, name='test_rabbitmq')
        cls.con = Connection(host='127.0.0.1', port=5672)
        cls.btr.status_code = 0
        cls.agent.end_transaction_request(cls.btr)

    def test_rabbitmq(self):
        self.assertIsInstance(self.btr, transactions.TransactionReq)
        self.assertEqual(self.btr.name, 'test_rabbitmq')
        self.assertEqual(self.btr.entry_type, 201)
        self.assertIsNot(self.btr.request_id, None)

    # def test_rabbitmq_Backend(self):
    #     self.assertIsInstance(self.btr.exitcalls[0].backend, Backend)
    #     self.assertEqual(self.btr.exitcalls[0].backend.connType, 'AMQP')
    #     self.assertEqual(self.btr.exitcalls[0].backend.name, 'AMQP://127.0.0.1:5672')
    #     self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['HOST'], '127.0.0.1')
    #     self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['PORT'], '5672')
    #     self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['VENDOR'], 'AMQP')

    # def test_rabbitmq_Exitcall(self):
    #     self.assertIsInstance(self.btr.exitcalls[0], ExitCall)
