import Bonree
from Bonree.agent.core.agent import Agent
from Bonree.agent.models.exitcalls import ExitCall, Backend
from Bonree.agent.models import transactions
import requests
import unittest


class TestRequests(unittest.TestCase):

    @classmethod
    def setUpClass(cls):
        cls.agent = Agent()
        cls.agent.start()
        cls.agent.enable = True
        Bonree.agent.bootstrap()
        cls.btr = cls.agent.start_transaction_request(transactions.ENTRY_PYTHON_WSGI, name='test_requests')
        requests.get('https://www.baidu.com')
        cls.btr.status_code = 0
        cls.agent.end_transaction_request(cls.btr)

    def test_requests(self):
        self.assertIsInstance(self.btr, transactions.TransactionReq)
        self.assertEqual(self.btr.name, 'test_requests')
        self.assertEqual(self.btr.entry_type, 201)
        self.assertIsNotNone(self.btr.request_id)

    def test_requestsExitcall(self):
        self.assertIsInstance(self.btr.exitcalls[0], ExitCall)
        self.assertEqual(self.btr.exitcalls[0].operation, '/')
        self.assertEqual(self.btr.exitcalls[0].summary, '/')

    def test_requestsBackend(self):
        self.assertIsInstance(self.btr.exitcalls[0].backend, Backend)
        self.assertEqual(self.btr.exitcalls[0].backend.connType, 'https')
        self.assertEqual(self.btr.exitcalls[0].backend.name, 'https://www.baidu.com:443')
        self.assertEqual(self.btr.exitcalls[0].backend.tipe, 201)
        self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['HOST'], 'www.baidu.com')
        self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['PORT'], '443')
        self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['QUERY STRING'], '')
        self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['URL'], '/')

