import Bonree
from Bonree.agent.core.agent import Agent
from Bonree.agent.models.exitcalls import ExitCall, Backend
from Bonree.agent.models import transactions
import urllib3
import unittest


class TestUrllib3(unittest.TestCase):

    @classmethod
    def setUpClass(cls):
        cls.agent = Agent()
        cls.agent.start()
        cls.agent.enable = True
        Bonree.agent.bootstrap()
        cls.btr = cls.agent.start_transaction_request(transactions.ENTRY_PYTHON_WSGI, name='test_urllib3')
        http = urllib3.PoolManager()
        http.request('GET', 'http://www.baidu.com')
        cls.btr.status_code = 0
        cls.agent.end_transaction_request(cls.btr)

    def test_urllib3(self):
        self.assertIsInstance(self.btr, transactions.TransactionReq)
        self.assertEqual(self.btr.name, 'test_urllib3')
        self.assertEqual(self.btr.entry_type, 201)
        self.assertIsNotNone(self.btr.request_id)

    def test_urllib3Exitcall(self):
        self.assertIsInstance(self.btr.exitcalls[0], ExitCall)
        self.assertEqual(self.btr.exitcalls[0].operation, '/')
        self.assertEqual(self.btr.exitcalls[0].summary, '/')

    def test_urllib3Backend(self):
        self.assertIsInstance(self.btr.exitcalls[0].backend, Backend)
        self.assertEqual(self.btr.exitcalls[0].backend.connType, 'http')
        self.assertEqual(self.btr.exitcalls[0].backend.name, 'http://www.baidu.com:80')
        self.assertEqual(self.btr.exitcalls[0].backend.tipe, 201)
        self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['HOST'], 'www.baidu.com')
        self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['PORT'], '80')
        self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['QUERY STRING'], '')
        self.assertEqual(self.btr.exitcalls[0].backend.identifying_properties['URL'], '/')

